#include "pitches.h"
#include <Servo.h>

Servo servo;
#define trigPin 7
#define echoPin 6
int buzzer = 9;
int randomSong;


//Song list
// Here you make the songs by using the Notes from pitches.h .  

//"melody" contains the notes the buzzer has to play
//"noteDurations" are the note durations. 4 = quarter note and 8 = eighth note etc. 

//Melody 1-------------------------------------------------------
int melody[] = {
  NOTE_C4, NOTE_G3, NOTE_G3
};

int noteDurations[] = {
  4, 8, 8
};

//Melody2--------------------------------------------------------
int melody2[] = {
  NOTE_D5, NOTE_E5, NOTE_A4
};

int noteDurations2[] = {
  4, 4, 8
};
//---------------------------------------------------------------

void setup() {

  pinMode(buzzer, OUTPUT);
  Serial.begin(9600);
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  servo.attach(3);

  // These are used to generate the random melody
  randomSeed(analogRead(A0));
  randomSong = random(1, 3);
}

void loop() {

  //This checks if there is an object in sight of the sensor
  long duration, distance;
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  duration = pulseIn(echoPin, HIGH);
  distance = (duration / 2) / 29.1;
  randomSong = random(1, 3);

  // If there are no objects close enough then the servo motor will stay put
  if (distance > 20 && distance > 10) {
    noTone(buzzer);
    servo.write(0);
  }

  // If there are objects close enough the servo motor and buzzer willt activate and shoots out a card.
  // If the object (hand) stays close to the sensor the servo motor will keep rotating back and forth causing to shoot cards.
  // It will only stop if you remove the object/hand form the sensor's sight.
  if (distance < 10 && distance > 0) {
    Serial.println("distance is onder 10");
    servo.write(180);
    delay(330);
    servo.write(0);

    // Switches between melody's randomized by "randomSong"
    switch (randomSong) {
      case 1:
        MelodyPlayer();
        break;

      case 2:
        MelodyPlayer2();
        break;
    }
  }
  Serial.print("random number =");
  Serial.println(randomSong);
}


// Melody Player Functions, these functions plays the songs

void MelodyPlayer() {
  for (int thisNote = 0; thisNote < 3; thisNote++) {
    int noteDuration = 1000 / noteDurations[thisNote];
    tone(buzzer, melody[thisNote], noteDuration);
    int pauseBetweenNotes = noteDuration * 1.30;
    delay(pauseBetweenNotes);
    noTone(buzzer);
  }
}

void MelodyPlayer2() {
  for (int thisNote = 0; thisNote < 3; thisNote++) {
    int noteDuration = 1000 / noteDurations2[thisNote];
    tone(buzzer, melody2[thisNote], noteDuration);
    int pauseBetweenNotes = noteDuration * 1.30;
    delay(pauseBetweenNotes);
    noTone(buzzer);
  }
}
